/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2008 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.system.vo;

import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import jp.mosp.common.CommonConst;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.vo.MosPVo;

import jp.mosp.system.dto.MWorkTypeDto;

public class WorkTypeMasterListVo extends MosPVo {

	private static final long serialVersionUID = -3051204572322360172L;

	// URL、CSS
	private static final String RETURN_URL	= "/jsp/system/workTypeMasterList.jsp";
	private static final String EXTRA_JS		= "/pub/system/js/workTypeMasterList.js";
	private static final String EXTRA_CSS		= "/pub/system/css/workTypeMasterList.css";

	// 画面サブタイトル
	public final String SUB_TITLE = CommonConst.TTL_WORK_TYPE_MASTER;

	//定数
	public static final int SEARCH_OFF = 0;
	public static final int SEARCH_ON  = 1;

	// パラメータ名
	public static final String PRM_TXT_SHIFT_CODE = "txtShiftCode";
	public static final String PRM_TXT_SHIFT_NAME = "txtShiftName";
	public static final String PRM_PLT_DELETE		= "pltDelete"	;	

	// フィールド
	private String[]	aryShiftCode;
	private String[]	aryShiftName;
	private String[]	aryWorkTable;
	private String[]	aryDelete	;
	private String		txtShiftCode;
	private String		txtShiftName;
	private String		pltDelete	;

	// フィールド名及び制限
	public static final String NAM_SHIFT_CODE 	= CommonConst.NAM_COMMON_CODE;
	public static final String NAM_SHIFT_NAME 	= CommonConst.NAM_WORKING_TYPE;
	public static final String NAM_WORKING_TABLE	= CommonConst.NAM_WORKING_TABLE_INFO;
	public static final String NAM_DELETE    		= CommonConst.NAM_DELETE_FLAG;

	public static final int	LEN_SHIFT_CODE 	= 10;
	public static final int	LEN_SHIFT_NAME	= 50;

	// ソートキー	
	public final String KEY_SHIFT_CODE	= "keyShiftCode";
	public final String KEY_SHIFT_NAME	= "keyShiftName";
	public final String KEY_DELETE		= "keyDelete"	;

	// モード(0：検索なし、1：検索あり)
	private int searchmode;

	/**
	 * コンストラクタ
	 */
	public WorkTypeMasterListVo() {
		super();
		setRetUrl(RETURN_URL);
		addExtraJs(EXTRA_JS);
		setExtraCss(EXTRA_CSS);
		txtShiftCode		= "";
		txtShiftName		= "";
		aryShiftCode		= new String[0];
		aryShiftName		= new String[0];
		aryWorkTable		= new String[0];
		aryDelete			= new String[0];
		setFormerKey(KEY_SHIFT_CODE);
	}

	/**
	 * パラメータ設定
	 * @param request リクエスト
	 */
	public void setParams(HttpServletRequest request) {
		txtShiftCode = request.getParameter(PRM_TXT_SHIFT_CODE);
		txtShiftName = request.getParameter(PRM_TXT_SHIFT_NAME);
		pltDelete    = request.getParameter(PRM_PLT_DELETE);
	}

	/**
	 * フィールド設定
	 * @param listWorkingTable		勤務形態リスト
	 */
	public void setFields(List listWorkingTable) {
		// リストの設定
		list = listWorkingTable;
		// データ総数の取得
		count = listWorkingTable.size();
		// 配列の初期化
		aryShiftCode	= new String[count];
		aryShiftName	= new String[count];
		aryWorkTable	= new String[count];
		aryDelete		= new String[count];
		// データの設定
		int i = 0;
		Iterator it = listWorkingTable.iterator();
		while (it.hasNext()) {
			MWorkTypeDto dto = (MWorkTypeDto)it.next();
			aryShiftCode[i]	= escapeHTML(dto.getShiftCode());
			aryShiftName[i]	= escapeHTML(dto.getShiftName());
			aryWorkTable[i]	= escapeHTML(util.convWorkTypeTimes(dto.getStartTime(), dto.getQuitTime()));
			if (dto.getDeleteFlag() == MospConst.DELETE_FLAG_OFF) {
				aryDelete[i] = escapeHTML(MospConst.DELETE_FLAG_OFF_NAME);
			} else if (dto.getDeleteFlag() == MospConst.DELETE_FLAG_ON) {
				aryDelete[i] = escapeHTML(MospConst.DELETE_FLAG_ON_NAME);
			}
			i++;
		}
	}

	/**
	 * JavaScript設定
	 * @param cls 情報取得クラス
	 * @throws IllegalAccessException
	 */
	@Override
	public String getDirectJs(Class cls) throws IllegalAccessException {
		StringBuffer sb = new StringBuffer();
		sb.append(super.getDirectJs(cls));
		return sb.toString();
	}

	// アクセサメソッド
	public String[] getEscAryShiftCode	() { return aryShiftCode.clone()	; }
	public String[] getEscAryShiftName	() { return aryShiftName.clone()	; }
	public String[] getEscAryWorkTable	() { return aryWorkTable.clone()	; }
	public String[] getEscAryDelete		() { return aryDelete.clone()		; }

	public String getTxtShiftCode	() { return txtShiftCode	; }
	public String getTxtShiftName	() { return txtShiftName	; }
	public String getPltDelete		() { return pltDelete		; }

	public String getEscTxtShiftName	() { return escapeHTML(txtShiftName)	; }
	public String getEscTxtShiftCode	() { return escapeHTML(txtShiftCode)	; }

	public void setPltDelete(int pltDelete) { this.pltDelete = String.valueOf(pltDelete); }

	public void setSearchmode(int searchmode) { this.searchmode = searchmode; }
	public int getSearchmode() { return searchmode; }

}
